<#assign html=JspTaglibs["/WEB-INF/struts-html.tld"]>
<#assign bean=JspTaglibs["/WEB-INF/struts-bean.tld"]>
<#assign logic=JspTaglibs["/WEB-INF/struts-logic.tld"]>

<@html.html>
<head>
    <title><@bean.message key="application.title"/> :: <@bean.message key="manage_user.title"/></title>
    <link rel="stylesheet" type="text/css" href='<@html.rewrite page=""/>/FTL/resources/css/mainstyle.css'>

    <script type="text/javascript" src="<@html.rewrite page=""/>/FTL/resources/js/common.js"></script>
    <script language="JavaScript">
    <!--

        function showObject(elname, e) 
        {
            if (document.getElementById(elname).style.visibility == "visible")
                hideObject(elname);
            else
                { 
                    document.getElementById(elname).style.visibility = "visible";
                    //window.status = (e.clientX + 2) +  ", " + (e.clientY + 2);
                    document.getElementById(elname).style.left = e.clientX + 2;
                    document.getElementById(elname).style.top = e.clientY + 2;
                    document.getElementById(elname).style.height = "auto";
                    document.getElementById(elname).style.width = "auto";
                }
        }

        function hideObject(elname) 
        {
            document.getElementById(elname).style.visibility = 'hidden';
            document.getElementById(elname).style.height = '1px';
            document.getElementById(elname).style.width = '1px';
        }

        // clicking on modifyUser will cause the form on this page to be filled with the user's values
        function fillForm(name, password, firstName, lastName, description, enabled, userroles)
        {
            document.getElementById('name').value = name;
            document.getElementById('password').value = password;
            document.getElementById('firstName').value = firstName;
            document.getElementById('lastName').value = lastName;
            document.getElementById('description').value = description;
            document.getElementById('enabled').checked = enabled;
            document.getElementById('submit').value = 'Update User';
            document.getElementById('action').value = 'updateuser';
            // fill the select box with the user's roles
            window.status = "";
            for (i = 0; i < userroles.length; i++)
                document.getElementById('userRoles').options[i] = new Option(userroles[i], userroles[i], false, false);
        }

        function selectAll()
        {   
            for (i = 0; i < document.getElementById('userRoles').length; i++)
                document.getElementById('userRoles').options[i].selected = "true";
        }   

    //-->
    </script>
	
</head>
<body>

<div id="Content">

<div class="MainTemplate">

<h4 align="center"><@bean.message key="manage_user.heading"/></h4>

<#-- Begin User Listing -->
<div align="center">
<table class="Listing">
	<#if users?exists>
		<tr>
		<th style="width: 5px;">&nbsp;&nbsp;</th>
		<th><@bean.message key="manage_user.add.name"/></th>
		<th><@bean.message key="manage_user.add.roles"/></th>	
		<th><@bean.message key="manage_user.add.enabled"/></th>
		</tr>
		<#list users as x>
		<tr>
		<td style="width: 5px;"><a href="javascript:;" onClick="showObject('${users[x_index].name}', event);">+</a></td>
		<td>${users[x_index].name}</td>
		<td>
			<#list alluserroles[x_index]?sort as y>
				${y[3..y?length-1]?cap_first}<#if y_has_next>, </#if> 
			</#list>
		</td>
		<td>${users[x_index].enabled?string("True", "False")}</td>
		</tr>
		</#list>
	<#else>
		<tr><td><b><u>There are no users in the system.</u></b></td></tr>
	</#if>
</table>	
</div>
<#-- End User Listing -->
<br>
<hr width="100%">

<#-- popup code starts here -->
<#if users?exists>
<#list users as x>
<div id="${users[x_index].name}" style="position: fixed; z-index:1; visibility:hidden; height: 1px; width: 1px;" >    
	<table class="DetailPopUpLayer">
		<tr>
			<th align="left">${users[x_index].name}</th>
			<th align="right" colspan="3"><a href="javascript:hideObject('${users[x_index].name}');">x</a></th></tr>
		<tr>
			<td><p><@bean.message key="manage_user.add.password"/></p></td>
			<td>${users[x_index].password}</td>
			<td><p><@bean.message key="manage_user.add.enabled"/></p></td>
			<td>${users[x_index].enabled?string("True", "False")}</td>
		</tr>
		<tr>
			<td><p><@bean.message key="manage_user.add.firstName"/></p></td>
			<td>${users[x_index].firstName}</td>
			<td><p><@bean.message key="manage_user.add.lastName"/></p></td>
			<td>${users[x_index].lastName}</td>
		</tr>
		<tr>
			<td><p><@bean.message key="manage_user.add.description"/></p></td>
			<td colspan="3">${users[x_index].description}</td>
		</tr>
		<tr>
			<td colspan="4">
			<a href="javascript:fillForm('${users[x_index].name}', '${users[x_index].password}', 
				'${users[x_index].firstName}', '${users[x_index].lastName}', 
				'${users[x_index].description}', '${users[x_index].enabled?string("true", "false")}',
				new Array(<#list alluserroles[x_index]?sort as y>'${y}'<#if y_has_next>, </#if></#list>));">Modify User</a></td>
		</tr>
	</table>
</div>
</#list>
</#if>
<#-- popup code ends here -->


<#-- ************* Begin Form: ADDING A USER ************* -->
<h5 align="center"><@bean.message key="manage_user.add"/></h5>
<@html.form styleId="userForm" action="/adduser">
<@html.hidden styleId="action" property="action" value="adduser"/>
<div align="center">
<table class="AddElement">
  <tr>
    <td><@bean.message key="manage_user.add.name"/>:</td>
    <td><@html.text styleId="name" property="name" size="20" maxlength="100"/></td>
	<td><@bean.message key="manage_user.add.password"/>:</td>
    <td><@html.text styleId="password" property="password" size="20" maxlength="100"/></td>
  </tr>
  <tr>
    <td><@bean.message key="manage_user.add.firstName"/>:</td>
    <td><@html.text styleId="firstName" property="firstName" size="20" maxlength="30"/></td>
    <td><@bean.message key="manage_user.add.lastName"/>:</td>
    <td><@html.text styleId="lastName" property="lastName" size="20" maxlength="30"/></td>  
  </tr>
  <tr>
    <td><@bean.message key="manage_user.add.description"/>:</td>
	<td colspan="3" ><@html.textarea styleId="description" property="description" cols="50" rows="4"/></td>
  </tr>
  <tr>
    <td><@bean.message key="manage_user.add.enabled"/>:</td>
	<td><@html.checkbox styleId="enabled" property="enabled"/></td>
  </tr>
  <#-- list all roles in the system, so that admin can select which one's the user can belong to -->
  <tr>
	<td align="center">
		<table><tr>
		<td>
			<@html.select multiple="true" styleId="userRoles" property="roles" size="5"></@html.select>
		</td>
		<td>
			<a href="javascript:;" onclick="moveSelection('allRoles', 'userRoles');" id="moveleft">&lt;&lt;</a>
			<br><br>
			<a href="javascript:;" onclick="moveSelection('userRoles', 'allRoles');" id="moveright">&gt;&gt;</a>
		</td>
		<td>
			<select MULTIPLE id="allRoles" size="5">
				<#if allroles?exists>
				<#list allroles as x>
					<option value="${allroles[x_index].name}">${allroles[x_index].name}</option>
				</#list>
				</#if>
			</select>
		</td>
		</tr></table>
	</td>
  </tr>  
  <tr>
  	<td>&nbsp;</td>
    <td align="center"><@html.submit styleId="submit" value="Submit" onclick="selectSelects();"/></td>
    <td align="center"><@html.reset value="Clear"/></td>
	<td>&nbsp;</td>
  </tr>
</table>
</div>
</@html.form>
<#-- ************* End Form: ADDING A USER ************* -->



</div> <#-- End MainTemplate -->
</div> <#-- End Content Layer -->

</body>
</@html.html>
